LeetCode 题解(94): Word Ladder

2024-05-28 09:18
文章标签 leetcode 题解 word 94 ladder

本文主要是介绍LeetCode 题解(94): Word Ladder,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目:

Given two words (beginWord and endWord), and a dictionary, find the length of shortest transformation sequence from beginWord to endWord, such that:

  1. Only one letter can be changed at a time
  2. Each intermediate word must exist in the dictionary

For example,

Given:
start = "hit"
end = "cog"
dict = ["hot","dot","dog","lot","log"]

As one shortest transformation is "hit" -> "hot" -> "dot" -> "dog" -> "cog",
return its length 5.

Note:

  • Return 0 if there is no such transformation sequence.
  • All words have the same length.
  • All words contain only lowercase alphabetic characters.
题解:

用BFS + 单Queue + 每次与wordDict比较,C++可以刚刚通过时间测试,java不能通过时间测试。于是网上学来BFS + 双Queue + 每次修改一个字符并与wordDict比较,每次止血比较 stringLength * 26次。

C++版:

class Solution {
public:int ladderLength(string beginWord, string endWord, unordered_set<string>& wordDict) {if(beginWord == endWord)return 2;if(wordDict.empty())return 0;wordDict.insert(endWord);queue<pair<string, int>> forward;forward.push(pair<string, int>(beginWord, 1));if(wordDict.find(beginWord) != wordDict.end())wordDict.erase(beginWord);while(!forward.empty()) {pair<string, int> front = forward.front();forward.pop();if(front.first == endWord)return front.second;for(unordered_set<string>::iterator iter = wordDict.begin(); iter != wordDict.end(); ) {if(distance(*iter, front.first)) {forward.push(pair<string, int>(*iter, front.second+1));wordDict.erase(iter++);} else {iter++;}}cout << endl;}return 0;}bool distance(const string& a, const string& b) {int diff = 0;for(unsigned int i = 0; i < a.length(); i++) {if(a[i] != b[i])diff++;if(diff > 1)return false;}if(diff == 1)return true;elsereturn false;}
};

Java版:

注意String比较的时候要用.equals()

public class Solution {public int ladderLength(String beginWord, String endWord, Set<String> wordDict) {if(beginWord == null || endWord == null || wordDict.size() == 0)return 0;Queue<String> queue1 = new LinkedList<>();Queue<String> queue2 = new LinkedList<>();queue1.add(beginWord);int distance = 1;while(wordDict.size() != 0 && queue1.size() != 0) {while(queue1.size() != 0) {String current = queue1.poll();for(int i = 0; i < current.length(); i++) {for(char j = 'a'; j <= 'z'; j++) {String temp = current;if(current.charAt(i) == j)continue;StringBuilder newString = new StringBuilder(current);newString.setCharAt(i, j);current = newString.toString();if(current.equals(endWord))return distance + 1;if(wordDict.contains(current)) {queue2.add(current);wordDict.remove(current);}current = temp;}}}distance += 1;queue1.addAll(queue2);queue2.clear();}return 0;}
}

Python版:

注意复制deque的时候要用深copy。import copy

a = copy.copy(b)

from collections import dequeclass Solution:# @param beginWord, a string# @param endWord, a string# @param wordDict, a set<string># @return an integerdef ladderLength(self, beginWord, endWord, wordDict):if beginWord == None or endWord == None or len(wordDict) == 0:return 0q1 = deque()q1.append(beginWord)q2 = deque()distance = 1while len(wordDict) != 0 and len(q1) != 0:while len(q1) != 0:current = q1.pop()for i in range(len(current)):temp = currentfor j in "abcdefghijklmnopqrstuvwxyz":if j == i:continuecurrent = current[0:i] + j + current[i+1:]if current == endWord:return distance + 1if current in wordDict:q2.append(current)wordDict.remove(current)current = tempdistance += 1q1 = copy.copy(q2)q2.clear()return 0


这篇关于LeetCode 题解(94): Word Ladder的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1010150

相关文章

哈希leetcode-1

目录 1前言 2.例题  2.1两数之和 2.2判断是否互为字符重排 2.3存在重复元素1 2.4存在重复元素2 2.5字母异位词分组 1前言 哈希表主要是适合于快速查找某个元素(O(1)) 当我们要频繁的查找某个元素,第一哈希表O(1),第二,二分O(log n) 一般可以分为语言自带的容器哈希和用数组模拟的简易哈希。 最简单的比如数组模拟字符存储,只要开26个c

leetcode-24Swap Nodes in Pairs

带头结点。 /*** Definition for singly-linked list.* public class ListNode {* int val;* ListNode next;* ListNode(int x) { val = x; }* }*/public class Solution {public ListNode swapPairs(L

leetcode-23Merge k Sorted Lists

带头结点。 /*** Definition for singly-linked list.* public class ListNode {* int val;* ListNode next;* ListNode(int x) { val = x; }* }*/public class Solution {public ListNode mergeKLists

C++ | Leetcode C++题解之第393题UTF-8编码验证

题目: 题解: class Solution {public:static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num &

【每日一题】LeetCode 2181.合并零之间的节点(链表、模拟)

【每日一题】LeetCode 2181.合并零之间的节点(链表、模拟) 题目描述 给定一个链表,链表中的每个节点代表一个整数。链表中的整数由 0 分隔开,表示不同的区间。链表的开始和结束节点的值都为 0。任务是将每两个相邻的 0 之间的所有节点合并成一个节点,新节点的值为原区间内所有节点值的和。合并后,需要移除所有的 0,并返回修改后的链表头节点。 思路分析 初始化:创建一个虚拟头节点

C语言 | Leetcode C语言题解之第393题UTF-8编码验证

题目: 题解: static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num & MASK1) == 0) {return

【JavaScript】LeetCode:16-20

文章目录 16 无重复字符的最长字串17 找到字符串中所有字母异位词18 和为K的子数组19 滑动窗口最大值20 最小覆盖字串 16 无重复字符的最长字串 滑动窗口 + 哈希表这里用哈希集合Set()实现。左指针i,右指针j,从头遍历数组,若j指针指向的元素不在set中,则加入该元素,否则更新结果res,删除集合中i指针指向的元素,进入下一轮循环。 /*** @param

C - Word Ladder题解

C - Word Ladder 题解 解题思路: 先输入两个字符串S 和t 然后在S和T中寻找有多少个字符不同的个数(也就是需要变换多少次) 开始替换时: tips: 字符串下标以0开始 我们定义两个变量a和b,用于记录当前遍历到的字符 首先是判断:如果这时a已经==b了,那么就跳过,不用管; 如果a大于b的话:那么我们就让s中的第i项替换成b,接着就直接输出S就行了。 这样

解决Office Word不能切换中文输入

我们在使用WORD的时可能会经常碰到WORD中无法输入中文的情况。因为,虽然我们安装了搜狗输入法,但是到我们在WORD中使用搜狗的输入法的切换中英文的按键的时候会发现根本没有效果,无法将输入法切换成中文的。下面我就介绍一下如何在WORD中把搜狗输入法切换到中文。

LeetCode:64. 最大正方形 动态规划 时间复杂度O(nm)

64. 最大正方形 题目链接 题目描述 给定一个由 0 和 1 组成的二维矩阵,找出只包含 1 的最大正方形,并返回其面积。 示例1: 输入: 1 0 1 0 01 0 1 1 11 1 1 1 11 0 0 1 0输出: 4 示例2: 输入: 0 1 1 0 01 1 1 1 11 1 1 1 11 1 1 1 1输出: 9 解题思路 这道题的思路是使用动态规划